//#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "include/lcd_modul.h"
#include "include/uart_modul.h"
//#include "include/counter_modul.h"

#define MaxLen  120
  unsigned char myUSART_tx_mes_1[] = "       ******ATMega8 Evaluation Software******\n\r            --Created by Stephan Gebauer--\n\r"; //Sendebuffer             
  unsigned char myUSART_tx_prompt[] = "ATMega8>" ;
 volatile unsigned char  USART_r_Buffer[MaxLen]; // Empfangsbuffer
 volatile unsigned char  * myUSART_tx ;
 unsigned char USART_received[MaxLen]; // fertig empfangener string
uint8_t ov0_cnt  = 0 ;
uint8_t cmp2_cnt = 0 ;



int main(void)
  {

   DDRC  = 0xff ; // Setzt das Richtungsregister des Ports B auf 0xff(alle Pins als Ausgang)
   PORTC = 0xFF ; // Alle Ausgnge von PortB auf 1 setzten ( Alle LEDs aus!! )
   lcd_init();

   set_cursor(0,1);
   lcd_string("Hallo, es funktioniert!");
   _delay_ms(100);
   set_cursor(0,2);
   
   myUSART_tx = &myUSART_tx_mes_1[0] ; // Ersten Text Ausgeben
   USART_Init(UBRR_VAL);
   sei();   //Interrupt wieder global freigeben


  for(;;) // Endlosschleife, Hauptprogramm
   {
    	   
      if((USART_reg.TXC_tatus == 1) & (USART_reg.prompt_tx == 0))
       {
		cli(); 
	    USART_reg.prompt_tx = 1 ; 
		USART_reg.TXC_tatus = 0 ; 
	    myUSART_tx = &myUSART_tx_prompt[0] ; // Der Zeiger wird nicht geaendert WARUM?!???
		sei();
        UCSRB |= (1 << UDRIE) ;
		ov0_cnt++;
		//lcd_string("1.bliblablupp");
       }
	   
	   if (ov0_cnt == 1)
	   {
	    ov0_cnt = 0 ;
		PORTC ^= (1 << 2);
	   }
   } // Endlosschleife, Hauptprogramm ende
   return(0);
  }

ISR(USART_UDRE_vect)
  { // ACHTUNG!!  FINGER WEG!!!!!!! Das hier funktioniert....hehe
    static uint8_t StringLen ;
	
   if ( *myUSART_tx != '\0')
    { // string senden bis string ende Zeichen
	  UDR = *myUSART_tx ; // naechstes Zeichen ins udr
      StringLen++; //mitzaehlen fuer naechstes Zeichen im array
	  myUSART_tx++ ;
	}
   else
    {
     StringLen = 0; // zeichenzhler zurcksetzten
	 USART_reg.TXC_tatus = 1 ; // kompletter string gesendet
	 UCSRB &=  ~(1 << UDRIE); // UDRIE bit lschen, damit wird dieser IRQ nicht mehr ausgeloest
    }
   sei();   //Interrupt wieder global freigeben
  }

ISR(USART_RXC_vect)
  {
   static uint8_t StringLen ;
   uint8_t NextChar;

   NextChar = UDR ; // USART Datenregister auslesen
  	 
   if ( NextChar != '\n' && StringLen < MaxLen - 1 )
    { // solange lesen bis Return oder maximale lnge
	  USART_r_Buffer[StringLen] = NextChar ;
      StringLen++ ;
	}
   else
    {
   	 USART_r_Buffer[StringLen+1]  = '\0'; // das stringende anzeigen
     StringLen = 0;
     USART_reg.RXC_tatus = 1 ; // kompletten string empfangen
    }
   sei()      ;   //Interrupt wieder global freigeben
  }
/*
ISR(TIMER0_OVF_vect)
  {
   ov0_cnt++ ;
   sei()     ;   //Interrupt wieder global freigeben
  }

ISR(TIMER2_OVF_vect)
  {
   PORTC |= (1 << 2) ;//wenn ja lschen (LED an!!!)
   sei()     ;   //Interrupt wieder global freigeben
  }
ISR(TIMER2_COMP_vect)
  {
   TCNT2 = 0x00 ;
   cmp2_cnt++   ;
   sei()        ;  //Interrupt wieder global freigeben
  }  */
