#include <avr/io.h>
#include "include/uart_modul.h"

void USART_Init( unsigned int ubrr)
{
    USART_reg.RXC_tatus = 0 ;
    USART_reg.TXC_tatus = 0 ;	
	USART_reg.ready     = 0 ;
	USART_reg.prompt_tx = 0 ;
/* Set baud rate */
UBRRH = (unsigned char)(ubrr>>8) ;
UBRRL = (unsigned char)ubrr ;
/* Set frame format: 8data, 1stop bit */
UCSRC |= (1<<URSEL)|(3<<UCSZ0) ;
/* Enable receiver and transmitter */
UCSRB |= (1<<RXEN)|(1<<TXEN) ;
/* Enable Interrupt for receiver and transmitter */
UCSRB |= (1<<RXCIE)|(1 << UDRIE)  ;
 DDRD  = 0x02 ;
//UDR = ' ' ;

}

void enable_usart_receive_int(void)
{
UCSRB |= (1<<RXCIE);
}

void enable_usart_transmit_int(void)
{
UCSRB |= (1<<TXCIE);
}

void disable_usart_receive_int(void)
{
UCSRB |= (1<<RXCIE);
}

void disable_usart_transmit_int(void)
{
UCSRB |= (1<<TXCIE);
}

