#define F_CPU 16000000UL

/* UART-Init beim AT90S2313 */
#ifndef F_CPU
/* In neueren Version der WinAVR/Mfile Makefile-Vorlage kann
F_CPU im Makefile definiert werden, eine nochmalige Definition
hier wuerde zu einer Compilerwarnung fuehren. Daher "Schutz" durch
#ifndef/#endif
Dieser "Schutz" kann zu Debugsessions fhren, wenn AVRStudio
verwendet wird und dort eine andere, nicht zur Hardware passende
Taktrate eingestellt ist: Dann wird die folgende Definition
nicht verwendet, sondern stattdessen der Defaultwert (8 MHz?)
von AVRStudio - daher Ausgabe einer Warnung falls F_CPU
noch nicht definiert: */
#warning "F_CPU war noch nicht definiert, wird nun nachgeholt mit 16000000"
#define F_CPU 16000000UL // Systemtakt in Hz - Definition als unsigned long beachten >> Ohne ergeben Fehler in der Berechnung
#endif
#define BAUD 9600UL // Baudrate
// Berechnungen  
#define UBRR_VAL ((F_CPU)/(BAUD*16))-1 // clever runden
#define BAUD_REAL (F_CPU/(16*(UBRR_VAL+1))) // Reale Baudrate
#define BAUD_ERROR ((BAUD_REAL*1000)/BAUD) // Fehler in Promille, 1000 = kein Fehler.
#if ((BAUD_ERROR<990) || (BAUD_ERROR>1010))
#error Systematischer Fehler der Baudrate grsser 1% und damit zu hoch!
#endif

struct {
unsigned RXC_tatus:1; // 1 Bit fr Empfangsstatus
unsigned TXC_tatus:1; // 1 Bit fr Sendestatus
unsigned ready:1; // Und hier noch mal ein Bit
unsigned prompt_tx:1; // Und hier noch mal ein Bit
//unsigned b2Bits:2; // Dieses Feld ist 2 Bits breit
// All das hat in einer einzigen Byte-Variable Platz.
// die 3 verbleibenden Bits bleiben ungenutzt
}  volatile USART_reg ;


void USART_Init( unsigned int ubrr) ;
void enable_usart_receive_int(void) ;
void enable_usart_transmit_int(void) ;
void disable_usart_receive_int(void) ;
void disable_usart_transmit_int(void) ;

